﻿Imports System.Data
Imports System.Data.OleDb

Public Class Form1

    Dim conexaoBD As OleDbConnection
    Dim arquivoBD As String
    Dim datSet As DataSet
    Dim tabelaBD As String
    Dim numeroItem As Integer

    Private Sub CarregaDados()
        arquivoBD = "C:\dados\NorthWind.mdb"
        Dim MyCon As String = "provider=microsoft.jet.oledb.4.0;Password="""";data source=" & arquivoBD
        conexaoBD = New OleDbConnection()
        conexaoBD.ConnectionString = MyCon
        Dim cmdSelect As OleDbCommand = New OleDbCommand()
        Dim datAdp As OleDbDataAdapter = New OleDbDataAdapter()
        datSet = New DataSet()
        Try
            tabelaBD = "Customers"
            ' Seleciona todos os campos
            Dim strSql As String = "SELECT * FROM " + tabelaBD + " ORDER BY ContactName"
            cmdSelect.CommandText = strSql
            cmdSelect.CommandType = CommandType.Text
            conexaoBD.Open()  ' abre a conexao
            cmdSelect.Connection = conexaoBD
            datAdp.SelectCommand = cmdSelect
            datAdp.Fill(datSet, tabelaBD)  'preenche o dataste
            ' Se não existem registros avisa
            Dim numeroRegistros As Integer = Me.BindingContext(datSet, tabelaBD).Count
            If numeroRegistros = 0 Then
                MessageBox.Show("Não existe registro no arquivo !", "Sem dados", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            Else
                DefineNoRaiz()
            End If
        Catch
            Throw
        Finally
            conexaoBD.Close()
        End Try
    End Sub

    Private Sub DefineNoRaiz()
        Try
            ' define o nó raiz do TreeView:  
            tvDados.Nodes.Add("Agenda Telefones")
            tvDados.Nodes(0).Tag = "RootDB"
            tvDados.Nodes(0).ImageIndex = 0
            tvDados.Nodes(0).SelectedImageIndex = 0
            ' Define os contatos
            DefineNomeContato()
            ' Define os telefones dos contatos
            DefineTelefone()
        Catch ex As Exception
            MessageBox.Show(ex.ToString(), "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub DefineNomeContato()
        Try
            'Define o nome do contato como um nó
            numeroItem = datSet.Tables(tabelaBD).Rows.Count
            For i As Integer = 0 To numeroItem - 1
                tvDados.Nodes(0).Nodes.Add(datSet.Tables(tabelaBD).Rows(i).ItemArray(2).ToString())
                tvDados.Nodes(0).Nodes(i).Tag = "ContactName"
                tvDados.Nodes(0).Nodes(i).ImageIndex = 1
                tvDados.Nodes(0).Nodes(i).SelectedImageIndex = 1
            Next
        Catch
            Throw
        End Try
    End Sub
    Private Sub DefineTelefone()
        Try
            ' Define o telefone como um nó
            For i As Integer = 0 To numeroItem - 1
                tvDados.Nodes(0).Nodes(i).Nodes.Add(datSet.Tables(tabelaBD).Rows(i).ItemArray(9).ToString())
                tvDados.Nodes(0).Nodes(i).Nodes(0).Tag = "Phone"
                tvDados.Nodes(0).Nodes(i).Nodes(0).ImageIndex = 3
                tvDados.Nodes(0).Nodes(i).Nodes(0).SelectedImageIndex = 3
            Next
        Catch
            Throw
        End Try
    End Sub

    Private Sub ExibeRegistros(ByVal Ordem As String, ByVal criterio As String)
        Try
            ' Usando o DataView para localiar o registro pelo critério
            Dim dv As DataView = New DataView(datSet.Tables(tabelaBD))
            'ordena
            dv.Sort = Ordem
            'localiza
            Dim i As Integer = dv.Find(criterio)
            Me.BindingContext(datSet, tabelaBD).Position = i
            'exibe os valores nas caixas de texto
            txtEmpresa.Text = datSet.Tables(tabelaBD).Rows(i).ItemArray(1).ToString()
            txtEndereco.Text = datSet.Tables(tabelaBD).Rows(i).ItemArray(4).ToString()
            txtCidade.Text = datSet.Tables(tabelaBD).Rows(i).ItemArray(5).ToString()
            txtPais.Text = datSet.Tables(tabelaBD).Rows(i).ItemArray(8).ToString()
        Catch ex As Exception
            MessageBox.Show(ex.ToString(), "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub btnCarregar_Click(sender As Object, e As EventArgs) Handles btnCarregar.Click
        Try
            'preenche o treeview
            CarregaDados()
            'tvDados.ExpandAll()
        Catch ex As Exception
            MessageBox.Show(ex.ToString(), "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub tvData_AfterSelect(sender As Object, e As TreeViewEventArgs) Handles tvDados.AfterSelect
        Try
            'se clicou no nome exibe os dados
            If e.Node.Level = 1 Then
                e.Node.Expand()
                ExibeRegistros(tvDados.Nodes(0).Nodes(1).Tag, e.Node.Text)
            End If
        Catch
            Throw
        End Try
    End Sub

    Private Sub picExpande_Click(sender As Object, e As EventArgs) Handles picExpande.Click
        tvDados.ExpandAll()
    End Sub

    Private Sub picRetrai_Click(sender As Object, e As EventArgs) Handles picRetrai.Click
        tvDados.CollapseAll()
    End Sub
End Class
